From d8248bd906983ff7d92ca6f8c0b9b3183f16c4f3 Mon Sep 17 00:00:00 2001
From: Endi Sukma Dewata <edewata@redhat.com>
Date: Sat, 11 Aug 2012 10:32:01 -0500
Subject: [PATCH] Reorganized REST server classes.

The factory and DAO classes used by REST services have been moved
into the com.netscape.cms.servlet.<component> packages.

Ticket #215
---
 .../model => cert}/CertEnrollmentRequestFactory.java         |  5 +++--
 .../cms/servlet/{request/model => cert}/CertRequestDAO.java  | 12 ++++++++----
 .../{request/model => cert}/CertRequestInfoFactory.java      |  4 ++--
 .../{request/model => cert}/CertReviewResponseFactory.java   |  9 +++++----
 .../src/com/netscape/cms/servlet/cert/CertService.java       |  1 -
 .../com/netscape/cms/servlet/cert/EnrollmentProcessor.java   |  1 -
 .../src/com/netscape/cms/servlet/cert/RenewalProcessor.java  |  1 -
 .../src/com/netscape/cms/servlet/cert/RequestProcessor.java  |  3 +--
 .../cms/servlet/{request/model => key}/KeyRequestDAO.java    | 10 ++++++++--
 base/common/src/com/netscape/cms/servlet/key/KeyService.java |  1 -
 .../servlet/profile/{model => }/PolicyConstraintFactory.java |  4 +++-
 .../servlet/profile/{model => }/PolicyDefaultFactory.java    |  4 +++-
 .../cms/servlet/profile/{model => }/ProfileInputFactory.java |  3 ++-
 .../servlet/profile/{model => }/ProfileOutputFactory.java    |  4 +++-
 .../cms/servlet/request/{model => }/CMSRequestDAO.java       |  6 ++++--
 .../com/netscape/cms/servlet/request/CertRequestService.java |  6 +++---
 .../com/netscape/cms/servlet/request/KeyRequestService.java  |  2 +-
 17 files changed, 46 insertions(+), 30 deletions(-)
 rename base/common/src/com/netscape/cms/servlet/{request/model => cert}/CertEnrollmentRequestFactory.java (91%)
 rename base/common/src/com/netscape/cms/servlet/{request/model => cert}/CertRequestDAO.java (94%)
 rename base/common/src/com/netscape/cms/servlet/{request/model => cert}/CertRequestInfoFactory.java (96%)
 rename base/common/src/com/netscape/cms/servlet/{request/model => cert}/CertReviewResponseFactory.java (96%)
 rename base/common/src/com/netscape/cms/servlet/{request/model => key}/KeyRequestDAO.java (95%)
 rename base/common/src/com/netscape/cms/servlet/profile/{model => }/PolicyConstraintFactory.java (90%)
 rename base/common/src/com/netscape/cms/servlet/profile/{model => }/PolicyDefaultFactory.java (93%)
 rename base/common/src/com/netscape/cms/servlet/profile/{model => }/ProfileInputFactory.java (93%)
 rename base/common/src/com/netscape/cms/servlet/profile/{model => }/ProfileOutputFactory.java (91%)
 rename base/common/src/com/netscape/cms/servlet/request/{model => }/CMSRequestDAO.java (96%)

diff --git a/base/common/src/com/netscape/cms/servlet/request/model/CertEnrollmentRequestFactory.java b/base/common/src/com/netscape/cms/servlet/cert/CertEnrollmentRequestFactory.java
similarity index 91%
rename from base/common/src/com/netscape/cms/servlet/request/model/CertEnrollmentRequestFactory.java
rename to base/common/src/com/netscape/cms/servlet/cert/CertEnrollmentRequestFactory.java
index 36c4adfca6b34a5ac99482212dbd06f486bbc69e..2aab69b376a06f4eef89b0b3037f265862d92ca1 100644
--- a/base/common/src/com/netscape/cms/servlet/request/model/CertEnrollmentRequestFactory.java
+++ b/base/common/src/com/netscape/cms/servlet/cert/CertEnrollmentRequestFactory.java
@@ -15,7 +15,7 @@
 //(C) 2012 Red Hat, Inc.
 //All rights reserved.
 //--- END COPYRIGHT BLOCK ---
-package com.netscape.cms.servlet.request.model;
+package com.netscape.cms.servlet.cert;
 
 import java.util.Enumeration;
 import java.util.Locale;
@@ -25,8 +25,9 @@ import com.netscape.certsrv.profile.EProfileException;
 import com.netscape.certsrv.profile.IProfile;
 import com.netscape.certsrv.profile.IProfileInput;
 import com.netscape.cms.servlet.common.CMSRequest;
+import com.netscape.cms.servlet.profile.ProfileInputFactory;
 import com.netscape.cms.servlet.profile.model.ProfileInput;
-import com.netscape.cms.servlet.profile.model.ProfileInputFactory;
+import com.netscape.cms.servlet.request.model.CertEnrollmentRequest;
 
 public class CertEnrollmentRequestFactory {
 
diff --git a/base/common/src/com/netscape/cms/servlet/request/model/CertRequestDAO.java b/base/common/src/com/netscape/cms/servlet/cert/CertRequestDAO.java
similarity index 94%
rename from base/common/src/com/netscape/cms/servlet/request/model/CertRequestDAO.java
rename to base/common/src/com/netscape/cms/servlet/cert/CertRequestDAO.java
index 3aacf1b884da947cc594d117495bd84b2ba64fa8..cac3371d0ac8fbeae29d6b69cfd6ae4d267e41b3 100644
--- a/base/common/src/com/netscape/cms/servlet/request/model/CertRequestDAO.java
+++ b/base/common/src/com/netscape/cms/servlet/cert/CertRequestDAO.java
@@ -15,7 +15,7 @@
 // (C) 2011 Red Hat, Inc.
 // All rights reserved.
 // --- END COPYRIGHT BLOCK ---
-package com.netscape.cms.servlet.request.model;
+package com.netscape.cms.servlet.cert;
 
 import java.util.ArrayList;
 import java.util.Collection;
@@ -37,11 +37,15 @@ import com.netscape.certsrv.profile.IProfileSubsystem;
 import com.netscape.certsrv.request.IRequest;
 import com.netscape.certsrv.request.IRequestQueue;
 import com.netscape.certsrv.request.RequestId;
-import com.netscape.cms.servlet.cert.EnrollmentProcessor;
-import com.netscape.cms.servlet.cert.RenewalProcessor;
-import com.netscape.cms.servlet.cert.RequestProcessor;
 import com.netscape.cms.servlet.processors.Processor;
+import com.netscape.cms.servlet.request.CMSRequestDAO;
 import com.netscape.cms.servlet.request.RequestNotFoundException;
+import com.netscape.cms.servlet.request.model.CMSRequestInfo;
+import com.netscape.cms.servlet.request.model.CMSRequestInfos;
+import com.netscape.cms.servlet.request.model.CertEnrollmentRequest;
+import com.netscape.cms.servlet.request.model.CertRequestInfo;
+import com.netscape.cms.servlet.request.model.CertRequestInfos;
+import com.netscape.cms.servlet.request.model.CertReviewResponse;
 
 
 /**
diff --git a/base/common/src/com/netscape/cms/servlet/request/model/CertRequestInfoFactory.java b/base/common/src/com/netscape/cms/servlet/cert/CertRequestInfoFactory.java
similarity index 96%
rename from base/common/src/com/netscape/cms/servlet/request/model/CertRequestInfoFactory.java
rename to base/common/src/com/netscape/cms/servlet/cert/CertRequestInfoFactory.java
index c21ea35c9a2948d722f29064d2e0317786c6c8de..3320d946a75907162d07e739b4a574163f5ea411 100644
--- a/base/common/src/com/netscape/cms/servlet/request/model/CertRequestInfoFactory.java
+++ b/base/common/src/com/netscape/cms/servlet/cert/CertRequestInfoFactory.java
@@ -16,7 +16,7 @@
 // All rights reserved.
 // --- END COPYRIGHT BLOCK ---
 
-package com.netscape.cms.servlet.request.model;
+package com.netscape.cms.servlet.cert;
 
 import java.math.BigInteger;
 
@@ -32,8 +32,8 @@ import com.netscape.certsrv.profile.IEnrollProfile;
 import com.netscape.certsrv.request.IRequest;
 import com.netscape.certsrv.request.RequestId;
 import com.netscape.certsrv.request.RequestStatus;
-import com.netscape.cms.servlet.cert.CertResource;
 import com.netscape.cms.servlet.request.CertRequestResource;
+import com.netscape.cms.servlet.request.model.CertRequestInfo;
 
 public class CertRequestInfoFactory {
 
diff --git a/base/common/src/com/netscape/cms/servlet/request/model/CertReviewResponseFactory.java b/base/common/src/com/netscape/cms/servlet/cert/CertReviewResponseFactory.java
similarity index 96%
rename from base/common/src/com/netscape/cms/servlet/request/model/CertReviewResponseFactory.java
rename to base/common/src/com/netscape/cms/servlet/cert/CertReviewResponseFactory.java
index a27437d0f182d369f2bd64cae3640a314179d5f7..7a7c3e9f086dda2670b89751e67cfc107eb995ad 100644
--- a/base/common/src/com/netscape/cms/servlet/request/model/CertReviewResponseFactory.java
+++ b/base/common/src/com/netscape/cms/servlet/cert/CertReviewResponseFactory.java
@@ -15,7 +15,7 @@
 //(C) 2012 Red Hat, Inc.
 //All rights reserved.
 //--- END COPYRIGHT BLOCK ---
-package com.netscape.cms.servlet.request.model;
+package com.netscape.cms.servlet.cert;
 
 import java.util.Enumeration;
 import java.util.Locale;
@@ -36,14 +36,15 @@ import com.netscape.certsrv.property.EPropertyException;
 import com.netscape.certsrv.request.IRequest;
 import com.netscape.cms.servlet.common.CMSRequest;
 import com.netscape.cms.servlet.processors.Processor;
+import com.netscape.cms.servlet.profile.PolicyConstraintFactory;
+import com.netscape.cms.servlet.profile.PolicyDefaultFactory;
+import com.netscape.cms.servlet.profile.ProfileInputFactory;
 import com.netscape.cms.servlet.profile.model.PolicyConstraint;
-import com.netscape.cms.servlet.profile.model.PolicyConstraintFactory;
 import com.netscape.cms.servlet.profile.model.PolicyDefault;
-import com.netscape.cms.servlet.profile.model.PolicyDefaultFactory;
 import com.netscape.cms.servlet.profile.model.ProfileInput;
-import com.netscape.cms.servlet.profile.model.ProfileInputFactory;
 import com.netscape.cms.servlet.profile.model.ProfilePolicy;
 import com.netscape.cms.servlet.profile.model.ProfilePolicySet;
+import com.netscape.cms.servlet.request.model.CertReviewResponse;
 
 public class CertReviewResponseFactory {
 
diff --git a/base/common/src/com/netscape/cms/servlet/cert/CertService.java b/base/common/src/com/netscape/cms/servlet/cert/CertService.java
index 365e89977c6413c7fdd74777355d9f726a3a91d7..0ccccf7bd893532fdf70baf95043c07ae6778882 100644
--- a/base/common/src/com/netscape/cms/servlet/cert/CertService.java
+++ b/base/common/src/com/netscape/cms/servlet/cert/CertService.java
@@ -64,7 +64,6 @@ import com.netscape.cms.servlet.cert.model.CertSearchRequest;
 import com.netscape.cms.servlet.cert.model.CertUnrevokeRequest;
 import com.netscape.cms.servlet.cert.model.CertData;
 import com.netscape.cms.servlet.processors.Processor;
-import com.netscape.cms.servlet.request.model.CertRequestDAO;
 import com.netscape.cms.servlet.request.model.CertRequestInfo;
 import com.netscape.cms.servlet.request.model.CertRetrievalRequest;
 import com.netscape.cmsutil.ldap.LDAPUtil;
diff --git a/base/common/src/com/netscape/cms/servlet/cert/EnrollmentProcessor.java b/base/common/src/com/netscape/cms/servlet/cert/EnrollmentProcessor.java
index 1d8a5695a1f6ed106385cf858b5e7475a3614a8a..cfd3be05f17ea36ce5f9d950ee5d2c13445ece1b 100644
--- a/base/common/src/com/netscape/cms/servlet/cert/EnrollmentProcessor.java
+++ b/base/common/src/com/netscape/cms/servlet/cert/EnrollmentProcessor.java
@@ -39,7 +39,6 @@ import com.netscape.cms.servlet.common.CMSRequest;
 import com.netscape.cms.servlet.profile.SSLClientCertProvider;
 import com.netscape.cms.servlet.profile.model.ProfileInput;
 import com.netscape.cms.servlet.request.model.CertEnrollmentRequest;
-import com.netscape.cms.servlet.request.model.CertEnrollmentRequestFactory;
 
 public class EnrollmentProcessor extends CertProcessor {
 
diff --git a/base/common/src/com/netscape/cms/servlet/cert/RenewalProcessor.java b/base/common/src/com/netscape/cms/servlet/cert/RenewalProcessor.java
index 3714d9807a6d6237ff397ba32568422a6d811234..2a9f1064858a60080d9dda2cf93b4f915bf724ce 100644
--- a/base/common/src/com/netscape/cms/servlet/cert/RenewalProcessor.java
+++ b/base/common/src/com/netscape/cms/servlet/cert/RenewalProcessor.java
@@ -45,7 +45,6 @@ import com.netscape.certsrv.request.IRequest;
 import com.netscape.cms.servlet.common.CMSRequest;
 import com.netscape.cms.servlet.profile.SSLClientCertProvider;
 import com.netscape.cms.servlet.request.model.CertEnrollmentRequest;
-import com.netscape.cms.servlet.request.model.CertEnrollmentRequestFactory;
 
 public class RenewalProcessor extends CertProcessor {
 
diff --git a/base/common/src/com/netscape/cms/servlet/cert/RequestProcessor.java b/base/common/src/com/netscape/cms/servlet/cert/RequestProcessor.java
index 2b26773f6882f668ff53fa9e3aec6c2bd6a276f8..b1757f130cd023115e0a7e46d3e073a4b0fe376f 100644
--- a/base/common/src/com/netscape/cms/servlet/cert/RequestProcessor.java
+++ b/base/common/src/com/netscape/cms/servlet/cert/RequestProcessor.java
@@ -52,13 +52,12 @@ import com.netscape.certsrv.request.RequestId;
 import com.netscape.certsrv.request.RequestStatus;
 import com.netscape.cms.profile.common.ProfilePolicy;
 import com.netscape.cms.servlet.common.CMSRequest;
+import com.netscape.cms.servlet.profile.ProfileOutputFactory;
 import com.netscape.cms.servlet.profile.model.PolicyDefault;
 import com.netscape.cms.servlet.profile.model.ProfileAttribute;
 import com.netscape.cms.servlet.profile.model.ProfileOutput;
-import com.netscape.cms.servlet.profile.model.ProfileOutputFactory;
 import com.netscape.cms.servlet.profile.model.ProfilePolicySet;
 import com.netscape.cms.servlet.request.model.CertReviewResponse;
-import com.netscape.cms.servlet.request.model.CertReviewResponseFactory;
 
 public class RequestProcessor extends CertProcessor {
 
diff --git a/base/common/src/com/netscape/cms/servlet/request/model/KeyRequestDAO.java b/base/common/src/com/netscape/cms/servlet/key/KeyRequestDAO.java
similarity index 95%
rename from base/common/src/com/netscape/cms/servlet/request/model/KeyRequestDAO.java
rename to base/common/src/com/netscape/cms/servlet/key/KeyRequestDAO.java
index 6e9de9290f1437912ba026559c16ba2586b9a413..2dffac22ee49b55a7bda6050ecbb273eeaf77221 100644
--- a/base/common/src/com/netscape/cms/servlet/request/model/KeyRequestDAO.java
+++ b/base/common/src/com/netscape/cms/servlet/key/KeyRequestDAO.java
@@ -15,7 +15,7 @@
 // (C) 2011 Red Hat, Inc.
 // All rights reserved.
 // --- END COPYRIGHT BLOCK ---
-package com.netscape.cms.servlet.request.model;
+package com.netscape.cms.servlet.key;
 
 import java.util.ArrayList;
 import java.util.Collection;
@@ -37,8 +37,14 @@ import com.netscape.certsrv.profile.IEnrollProfile;
 import com.netscape.certsrv.request.IRequest;
 import com.netscape.certsrv.request.RequestId;
 import com.netscape.certsrv.request.RequestStatus;
-import com.netscape.cms.servlet.key.KeyResource;
+import com.netscape.cms.servlet.request.CMSRequestDAO;
 import com.netscape.cms.servlet.request.KeyRequestResource;
+import com.netscape.cms.servlet.request.model.CMSRequestInfo;
+import com.netscape.cms.servlet.request.model.CMSRequestInfos;
+import com.netscape.cms.servlet.request.model.KeyArchivalRequest;
+import com.netscape.cms.servlet.request.model.KeyRecoveryRequest;
+import com.netscape.cms.servlet.request.model.KeyRequestInfo;
+import com.netscape.cms.servlet.request.model.KeyRequestInfos;
 
 /**
  * @author alee
diff --git a/base/common/src/com/netscape/cms/servlet/key/KeyService.java b/base/common/src/com/netscape/cms/servlet/key/KeyService.java
index ffd0ef7393dfe9a1117eb1a8c421c71de252cdfd..9657231135967b3306abba92078dade797c010ad 100644
--- a/base/common/src/com/netscape/cms/servlet/key/KeyService.java
+++ b/base/common/src/com/netscape/cms/servlet/key/KeyService.java
@@ -45,7 +45,6 @@ import com.netscape.cms.servlet.base.PKIService;
 import com.netscape.cms.servlet.key.model.KeyData;
 import com.netscape.cms.servlet.key.model.KeyDataInfo;
 import com.netscape.cms.servlet.key.model.KeyDataInfos;
-import com.netscape.cms.servlet.request.model.KeyRequestDAO;
 import com.netscape.cms.servlet.request.model.KeyRequestInfo;
 import com.netscape.cms.servlet.request.model.KeyRecoveryRequest;
 import com.netscape.cmsutil.ldap.LDAPUtil;
diff --git a/base/common/src/com/netscape/cms/servlet/profile/model/PolicyConstraintFactory.java b/base/common/src/com/netscape/cms/servlet/profile/PolicyConstraintFactory.java
similarity index 90%
rename from base/common/src/com/netscape/cms/servlet/profile/model/PolicyConstraintFactory.java
rename to base/common/src/com/netscape/cms/servlet/profile/PolicyConstraintFactory.java
index bd361a75226821b8d5a136df78a0772d0eda6878..5ceecd4a569b7ad71d0452c1b8aeef04c639af94 100644
--- a/base/common/src/com/netscape/cms/servlet/profile/model/PolicyConstraintFactory.java
+++ b/base/common/src/com/netscape/cms/servlet/profile/PolicyConstraintFactory.java
@@ -15,13 +15,15 @@
 // (C) 2012 Red Hat, Inc.
 // All rights reserved.
 // --- END COPYRIGHT BLOCK ---
-package com.netscape.cms.servlet.profile.model;
+package com.netscape.cms.servlet.profile;
 
 import java.util.Enumeration;
 import java.util.Locale;
 
 import com.netscape.certsrv.profile.IPolicyConstraint;
 import com.netscape.certsrv.property.Descriptor;
+import com.netscape.cms.servlet.profile.model.PolicyConstraint;
+import com.netscape.cms.servlet.profile.model.PolicyConstraintValue;
 
 public class PolicyConstraintFactory {
 
diff --git a/base/common/src/com/netscape/cms/servlet/profile/model/PolicyDefaultFactory.java b/base/common/src/com/netscape/cms/servlet/profile/PolicyDefaultFactory.java
similarity index 93%
rename from base/common/src/com/netscape/cms/servlet/profile/model/PolicyDefaultFactory.java
rename to base/common/src/com/netscape/cms/servlet/profile/PolicyDefaultFactory.java
index 6b9379f0bec126ed51a6ef648c83753708122f5f..01c19936dbcefcc0d2bf5fa12975c2663b569af2 100644
--- a/base/common/src/com/netscape/cms/servlet/profile/model/PolicyDefaultFactory.java
+++ b/base/common/src/com/netscape/cms/servlet/profile/PolicyDefaultFactory.java
@@ -15,7 +15,7 @@
 // (C) 2012 Red Hat, Inc.
 // All rights reserved.
 // --- END COPYRIGHT BLOCK ---
-package com.netscape.cms.servlet.profile.model;
+package com.netscape.cms.servlet.profile;
 
 import java.util.Enumeration;
 import java.util.Locale;
@@ -25,6 +25,8 @@ import com.netscape.certsrv.profile.IPolicyDefault;
 import com.netscape.certsrv.property.Descriptor;
 import com.netscape.certsrv.property.EPropertyException;
 import com.netscape.certsrv.request.IRequest;
+import com.netscape.cms.servlet.profile.model.PolicyDefault;
+import com.netscape.cms.servlet.profile.model.ProfileAttribute;
 
 public class PolicyDefaultFactory {
 
diff --git a/base/common/src/com/netscape/cms/servlet/profile/model/ProfileInputFactory.java b/base/common/src/com/netscape/cms/servlet/profile/ProfileInputFactory.java
similarity index 93%
rename from base/common/src/com/netscape/cms/servlet/profile/model/ProfileInputFactory.java
rename to base/common/src/com/netscape/cms/servlet/profile/ProfileInputFactory.java
index 67d3e9a2c4613c82ec4a37ba84d74016097ef4dc..1e9f4598ca3ada59f7fc457573e93c3aec888dc0 100644
--- a/base/common/src/com/netscape/cms/servlet/profile/model/ProfileInputFactory.java
+++ b/base/common/src/com/netscape/cms/servlet/profile/ProfileInputFactory.java
@@ -1,4 +1,4 @@
-package com.netscape.cms.servlet.profile.model;
+package com.netscape.cms.servlet.profile;
 
 import java.util.Enumeration;
 import java.util.Locale;
@@ -7,6 +7,7 @@ import com.netscape.certsrv.base.IArgBlock;
 import com.netscape.certsrv.profile.EProfileException;
 import com.netscape.certsrv.profile.IProfileInput;
 import com.netscape.certsrv.request.IRequest;
+import com.netscape.cms.servlet.profile.model.ProfileInput;
 
 public class ProfileInputFactory {
 
diff --git a/base/common/src/com/netscape/cms/servlet/profile/model/ProfileOutputFactory.java b/base/common/src/com/netscape/cms/servlet/profile/ProfileOutputFactory.java
similarity index 91%
rename from base/common/src/com/netscape/cms/servlet/profile/model/ProfileOutputFactory.java
rename to base/common/src/com/netscape/cms/servlet/profile/ProfileOutputFactory.java
index 93bbaa2c577fdbe1d4dfd9361c057ca6169bf5e3..e15875eff4a210b4cd3d33f654bfdf88e9863ebd 100644
--- a/base/common/src/com/netscape/cms/servlet/profile/model/ProfileOutputFactory.java
+++ b/base/common/src/com/netscape/cms/servlet/profile/ProfileOutputFactory.java
@@ -15,7 +15,7 @@
 //(C) 2012 Red Hat, Inc.
 //All rights reserved.
 //--- END COPYRIGHT BLOCK ---
-package com.netscape.cms.servlet.profile.model;
+package com.netscape.cms.servlet.profile;
 
 import java.util.Enumeration;
 import java.util.Locale;
@@ -24,6 +24,8 @@ import com.netscape.certsrv.profile.EProfileException;
 import com.netscape.certsrv.profile.IProfileOutput;
 import com.netscape.certsrv.property.Descriptor;
 import com.netscape.certsrv.request.IRequest;
+import com.netscape.cms.servlet.profile.model.ProfileAttribute;
+import com.netscape.cms.servlet.profile.model.ProfileOutput;
 
 public class ProfileOutputFactory {
 
diff --git a/base/common/src/com/netscape/cms/servlet/request/model/CMSRequestDAO.java b/base/common/src/com/netscape/cms/servlet/request/CMSRequestDAO.java
similarity index 96%
rename from base/common/src/com/netscape/cms/servlet/request/model/CMSRequestDAO.java
rename to base/common/src/com/netscape/cms/servlet/request/CMSRequestDAO.java
index 5ac984168c62d8d51e90452ab859669a82926f88..5d1df774db3740905c6b46eb3ce21b59993d9ebf 100644
--- a/base/common/src/com/netscape/cms/servlet/request/model/CMSRequestDAO.java
+++ b/base/common/src/com/netscape/cms/servlet/request/CMSRequestDAO.java
@@ -15,7 +15,7 @@
 // (C) 2011 Red Hat, Inc.
 // All rights reserved.
 // --- END COPYRIGHT BLOCK ---
-package com.netscape.cms.servlet.request.model;
+package com.netscape.cms.servlet.request;
 
 import java.net.URI;
 import java.util.ArrayList;
@@ -34,6 +34,8 @@ import com.netscape.certsrv.request.IRequestQueue;
 import com.netscape.certsrv.request.IRequestVirtualList;
 import com.netscape.certsrv.request.RequestId;
 import com.netscape.cms.servlet.base.model.Link;
+import com.netscape.cms.servlet.request.model.CMSRequestInfo;
+import com.netscape.cms.servlet.request.model.CMSRequestInfos;
 
 /**
  * @author alee
@@ -161,6 +163,6 @@ public abstract class CMSRequestDAO {
         return false;
     }
 
-    abstract  CMSRequestInfo createCMSRequestInfo(IRequest request, UriInfo uriInfo);
+    protected abstract CMSRequestInfo createCMSRequestInfo(IRequest request, UriInfo uriInfo);
 }
 
diff --git a/base/common/src/com/netscape/cms/servlet/request/CertRequestService.java b/base/common/src/com/netscape/cms/servlet/request/CertRequestService.java
index e1aa5659217cda484fd46ccee199aeace5484f8d..174b6d7fbcc24d12e29be7125ee616c962cc7d01 100644
--- a/base/common/src/com/netscape/cms/servlet/request/CertRequestService.java
+++ b/base/common/src/com/netscape/cms/servlet/request/CertRequestService.java
@@ -35,11 +35,11 @@ import com.netscape.certsrv.request.RequestId;
 import com.netscape.cms.servlet.base.BadRequestException;
 import com.netscape.cms.servlet.base.PKIException;
 import com.netscape.cms.servlet.base.PKIService;
-import com.netscape.cms.servlet.request.model.CertReviewResponse;
-import com.netscape.cms.servlet.request.model.CertRequestDAO;
+import com.netscape.cms.servlet.cert.CertRequestDAO;
+import com.netscape.cms.servlet.request.model.CertEnrollmentRequest;
 import com.netscape.cms.servlet.request.model.CertRequestInfo;
 import com.netscape.cms.servlet.request.model.CertRequestInfos;
-import com.netscape.cms.servlet.request.model.CertEnrollmentRequest;
+import com.netscape.cms.servlet.request.model.CertReviewResponse;
 import com.netscape.cmsutil.ldap.LDAPUtil;
 
 /**
diff --git a/base/common/src/com/netscape/cms/servlet/request/KeyRequestService.java b/base/common/src/com/netscape/cms/servlet/request/KeyRequestService.java
index e2afaf58c8f14d0051a61971fa42b447fbb1f59d..188bcb23c19e6de0e2e7112e71c6bd46d5f26216 100644
--- a/base/common/src/com/netscape/cms/servlet/request/KeyRequestService.java
+++ b/base/common/src/com/netscape/cms/servlet/request/KeyRequestService.java
@@ -27,8 +27,8 @@ import com.netscape.certsrv.base.EBaseException;
 import com.netscape.certsrv.request.RequestId;
 import com.netscape.cms.servlet.base.PKIException;
 import com.netscape.cms.servlet.base.PKIService;
+import com.netscape.cms.servlet.key.KeyRequestDAO;
 import com.netscape.cms.servlet.request.model.KeyArchivalRequest;
-import com.netscape.cms.servlet.request.model.KeyRequestDAO;
 import com.netscape.cms.servlet.request.model.KeyRequestInfo;
 import com.netscape.cms.servlet.request.model.KeyRequestInfos;
 import com.netscape.cms.servlet.request.model.KeyRecoveryRequest;
-- 
1.7.11.2